<?php
/**
 * @file
 * Contains \Drupal\webfactory_slave\Services\WebfactorySlaveController.
 */

namespace Drupal\webfactory_master\Controller;

use Drupal\Core\Controller\ControllerBase;
use Drupal\webfactory_master\Entity\SatelliteEntity;
use GuzzleHttp\Client;
use GuzzleHttp\Exception\ClientException;
use Symfony\Component\HttpFoundation\Response;

/**
 * Controller routines for webfactory slave routes.
 */
class SatelliteController extends ControllerBase {

  /**
   * Returns the admin page.
   *
   * @param int $id
   *   A satellite entity id.
   *
   * @return string Response
   *   Json response.
   */
  public function checkDeploy($id) {
    $sat = SatelliteEntity::load($id);
    $result = [
      'status' => 0,
    ];

    $ping_client = new Client([
      'base_uri' => 'http://' . $sat->get('host'),
      ['redirect.disable' => TRUE],
    ]);

    try {
      $response = $ping_client->get('/webfactory_slave/site?_format=hal_json', array('allow_redirects' => FALSE));

      $status = $response->getStatusCode();

      if ($status == 200) {
        $result['status'] = 1;
        $result['host'] = 'http://' . $sat->get('host');

        $sat->markAsDeployed();
        $sat->save();
      }
    }
    catch (ClientException $e) {

    }

    return new Response(json_encode($result));
  }

}
