<?php

/**
 * @file
 * Contains Drupal\webfactory_slave\MasterClientInterface.
 */

namespace Drupal\webfactory_slave;

/**
 * Define master client behavior.
 *
 * @package Drupal\webfactory_slave
 */
interface MasterClientInterface {

  /**
   * Fetch channels available for given satellite id.
   *
   * @return array
   *    List of channels.
   */
  public function getChannelsData($satellite_id);

  /**
   * Fetch entities exposed by given satellite.
   *
   * @return array
   *    List of remote entities.
   */
  public function getEntitiesData($channel_id, $satellite_id);

}
